/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/GUIForms/JFrame.java to edit this template
 */
package lab13;

import com.mongodb.BasicDBObject;
import com.mongodb.DB;
import com.mongodb.DBCollection;
import com.mongodb.DBCursor;
import com.mongodb.MongoClient;
import javax.swing.DefaultListModel;
import javax.swing.JOptionPane;

/**
 *
 * @author pasinee
 */
public class AddDocument extends javax.swing.JFrame {

    /**
     * Creates new form AddDocument
     */
    public AddDocument() {
        initComponents();
        this.setTitle("AddData");
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        bntExit = new javax.swing.JButton();
        LblAddID = new javax.swing.JLabel();
        LblAddEmp1 = new javax.swing.JLabel();
        txtEmp_id = new javax.swing.JTextField();
        bntSave = new javax.swing.JButton();
        LblAddID1 = new javax.swing.JLabel();
        txtPrice = new javax.swing.JTextField();
        LblAddID2 = new javax.swing.JLabel();
        ComDoc_type = new javax.swing.JComboBox<>();
        bntClear = new javax.swing.JButton();
        LblAddEmp2 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        ListDoc = new javax.swing.JList<>();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        bntExit.setFont(new java.awt.Font("Microsoft Sans Serif", 1, 18)); // NOI18N
        bntExit.setText("Exit");
        bntExit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bntExitActionPerformed(evt);
            }
        });

        LblAddID.setFont(new java.awt.Font("Microsoft Sans Serif", 1, 14)); // NOI18N
        LblAddID.setText("รหัสพนักงาน :");

        LblAddEmp1.setFont(new java.awt.Font("Microsoft Sans Serif", 1, 14)); // NOI18N
        LblAddEmp1.setText("เพิ่มข้อมูลพนักงาน");

        bntSave.setFont(new java.awt.Font("Microsoft Sans Serif", 1, 14)); // NOI18N
        bntSave.setText("บันทึก");
        bntSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bntSaveActionPerformed(evt);
            }
        });

        LblAddID1.setFont(new java.awt.Font("Microsoft Sans Serif", 1, 14)); // NOI18N
        LblAddID1.setText("จำนวนเงิน :");

        LblAddID2.setFont(new java.awt.Font("Microsoft Sans Serif", 1, 14)); // NOI18N
        LblAddID2.setText("Doc type :");

        ComDoc_type.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 12)); // NOI18N
        ComDoc_type.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "A", "ฺB", "C" }));

        bntClear.setFont(new java.awt.Font("Microsoft Sans Serif", 1, 14)); // NOI18N
        bntClear.setText("ยกเลิก");
        bntClear.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bntClearActionPerformed(evt);
            }
        });

        LblAddEmp2.setFont(new java.awt.Font("Microsoft Sans Serif", 1, 14)); // NOI18N
        LblAddEmp2.setText("ข้อมูลทั้งหมด");

        ListDoc.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 12)); // NOI18N
        jScrollPane1.setViewportView(ListDoc);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(17, 17, 17)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(LblAddEmp2)
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(LblAddEmp1)
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addComponent(LblAddID2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(LblAddID, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(txtEmp_id, javax.swing.GroupLayout.DEFAULT_SIZE, 153, Short.MAX_VALUE)
                                    .addComponent(ComDoc_type, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                .addGap(34, 34, 34)))
                        .addComponent(LblAddID1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(txtPrice, javax.swing.GroupLayout.PREFERRED_SIZE, 153, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGap(0, 0, Short.MAX_VALUE)
                        .addComponent(bntClear)
                        .addGap(30, 30, 30)
                        .addComponent(bntSave)))
                .addGap(141, 141, 141))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(bntExit, javax.swing.GroupLayout.PREFERRED_SIZE, 86, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(55, 55, 55))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(LblAddEmp1, javax.swing.GroupLayout.PREFERRED_SIZE, 51, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(LblAddID, javax.swing.GroupLayout.PREFERRED_SIZE, 26, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(txtEmp_id, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(LblAddID1, javax.swing.GroupLayout.PREFERRED_SIZE, 51, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(txtPrice, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(LblAddID2, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(ComDoc_type, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(8, 8, 8)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(bntSave)
                    .addComponent(bntClear))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(LblAddEmp2, javax.swing.GroupLayout.PREFERRED_SIZE, 51, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(bntExit)
                .addContainerGap(29, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void bntExitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bntExitActionPerformed
        setVisible(false);  // คำสั่งปิดหน้าจอ
    }//GEN-LAST:event_bntExitActionPerformed

    private void bntSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bntSaveActionPerformed
        try {

            String Emp_id = txtEmp_id.getText();
            String PriceText = txtPrice.getText();

            // เงื่อนไขหากไม่กรอกข้อมูลรหัสพนักงาน และไม่กรอกข้อมูลจำนวนเงิน
            if (Emp_id.isEmpty() && PriceText.isEmpty()) {
                JOptionPane.showMessageDialog(this, "กรุณากรอกข้อมูลรหัสพนักงาน และจำนวนเงิน");
                return;
            }

            // เงื่อนไขหากไม่กรอกข้อมูลจำนวนเงิน แต่กรอกข้อมูลรหัสพนักงาน
            if (Emp_id.isEmpty()) {
                JOptionPane.showMessageDialog(this, "กรุณากรอกข้อมูลรหัสพนักงาน");
                return;
            }

            // เงื่อนไขหากไม่กรอกข้อมูลรหัสพนักงาน แต่กรอกข้อมูลจำนวนเงิน 
            if (PriceText.isEmpty()) {
                JOptionPane.showMessageDialog(this, "กรุณากรอกข้อมูลจำนวนเงิน");
                return;
            }

            int Price = Integer.parseInt(txtPrice.getText());
            String Doc_type = ComDoc_type.getSelectedItem().toString();
            //คำสั่งติดต่อกับฐานข้อมูล
            MongoClient mongo = new MongoClient("localhost", 27017);
            DB db = mongo.getDB("BigC");
            DBCollection table = db.getCollection("Employee");
            BasicDBObject document = new BasicDBObject();
            document.put("emp_id", "" + Emp_id + "");
            DBCursor cursor1 = table.find(document);

            if (cursor1.length() == 0) { //Duplicate key checking
                document.put("emp_id", "" + Emp_id + "");
                document.put("price", Price);
                document.put("doc_type", "" + Doc_type + "");
                table.insert(document);

                JOptionPane.showMessageDialog(this, "Successfully inserting document"); //แสดง Dialog 

                // Clear ข้อมูลและ set เป็นค่าเริ่มต้น
                txtEmp_id.setText("");
                txtPrice.setText("");
                ComDoc_type.setSelectedIndex(0);

                // แสดงข้อมูลที่เลือก
                DBCursor cursor = table.find();
                DefaultListModel model = new DefaultListModel();
                while (cursor.hasNext()) {
                    model.addElement(cursor.next());
                }
                ListDoc.setModel(model);
            } else {
                JOptionPane.showMessageDialog(this, "Duplicate key not update");
            }

        } catch (Exception e) {
            //
        }
    }//GEN-LAST:event_bntSaveActionPerformed

    private void bntClearActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bntClearActionPerformed
        // Clear ข้อมูลและ set เป็นค่าเริ่มต้น
        txtEmp_id.setText("");
        txtPrice.setText("");
        ComDoc_type.setSelectedIndex(0);
    }//GEN-LAST:event_bntClearActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(AddDocument.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(AddDocument.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(AddDocument.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(AddDocument.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new AddDocument().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox<String> ComDoc_type;
    private javax.swing.JLabel LblAddEmp1;
    private javax.swing.JLabel LblAddEmp2;
    private javax.swing.JLabel LblAddID;
    private javax.swing.JLabel LblAddID1;
    private javax.swing.JLabel LblAddID2;
    private javax.swing.JList<String> ListDoc;
    private javax.swing.JButton bntClear;
    private javax.swing.JButton bntExit;
    private javax.swing.JButton bntSave;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextField txtEmp_id;
    private javax.swing.JTextField txtPrice;
    // End of variables declaration//GEN-END:variables
}
